%
% Original latex template: https://github.com/oskar456/beamer-skeleton
%

% Wide screen (aspect ratio 16:9)
%\documentclass[hyperref={pdfpagelabels=false},xcolor=dvipsnames,12pt,aspectratio=169]{beamer}

% Normal screen (aspect ratio 4:3)
\documentclass[hyperref={pdfpagelabels=false},xcolor=dvipsnames,12pt]{beamer}
\let\Tiny=\tiny

%\usepackage[czech]{babel}
\usepackage{xltxtra}
\usepackage{hyperref}
\usepackage{listings}
\hypersetup{colorlinks=false,hidelinks}
\setromanfont{DejaVu Serif}
\setsansfont{DejaVu Sans}
\setmonofont{DejaVu Sans Mono}
\lstset{language=Python}

\setbeamertemplate{navigation symbols}{}

\mode<presentation>
{
    \usetheme{Madrid}
    \usecolortheme[RGB={0,104,162}]{structure}
}
\AtBeginSection[]{
    \begin{frame}
        \centering
            \begin{beamercolorbox}[sep=12pt,center]{part title}
                \usebeamerfont{section title}\insertsection\par
            \end{beamercolorbox}
    \end{frame}
}

\title[Mentat system]{Mentat system}
\subtitle{Introduction and latest news}
\author{Jan Mach}
\institute[CESNET, a.l.e.]{\includegraphics[width=4cm]{../../img/logo/cesnet_RGB_raw}}
\logo{\includegraphics[width=1.5cm]{../../img/logo/cesnet_RGB_lrprotect}}
\date{v1.0, 2018-10-03}

% Automatic TOC generation at the beginning of each section (must be in preamble)
\AtBeginSection[]
{
    \begin{frame}
        \frametitle{Agenda}
        \tableofcontents[currentsection]
    \end{frame}
}
\AtBeginSubsection[]
{
    \begin{frame}
        \frametitle{Agenda}
        \tableofcontents[currentsection,currentsubsection]
    \end{frame}
}

\begin{document}


%-------------------------------------------------------------------------------


\section*{Opening}

{
\setbeamertemplate{logo}{}
\begin{frame}
    \titlepage
    \begin{figure}
        \includegraphics[width=2ex]{../../img/logo/cc}
        \hspace*{0.5ex}
        \includegraphics[width=2ex]{../../img/logo/by}

        \tiny Attribution 3.0 Unported (CC BY 3.0)
    \end{figure}
\end{frame}
}

\begin{frame}
    \frametitle{Agenda}
    \tableofcontents
\end{frame}


%-------------------------------------------------------------------------------


\section{Quick overview}

\begin{frame}
    \frametitle{Motivation}
    \begin{alertblock}{Key ideas}
        \begin{itemize}
            \item Resource consolidation
            \item Aid for CESNET-CERTS security team
            \item Aid for network administrators
        \end{itemize}
    \end{alertblock}
    \begin{block}{Main features}
        \begin{itemize}
            \item Gathering/receiving information from various sources
            \item Long term searchable persistent information storage
            \item Real-time and back information processing with various methods
            \item Fully automatic processing, enable performing of automatic actions on specific conditions
        \end{itemize}
    \end{block}
\end{frame}

\begin{frame}
    \frametitle{Architecture [1]}
    \begin{figure}
        \includegraphics[width=12cm]{../../img/mentat/mentat-overview}
    \end{figure}
    \begin{itemize}
        \item Implementation language: \href{https://www.python.org/}{\alert{Python3}}
        \item Data model: \href{https://idea.cesnet.cz/en/index}{\alert{IDEA}}
        \item Data storage: \href{https://www.postgresql.org/}{\alert{PostgreSQL}}
        \item Network communication protocol: \href{https://warden.cesnet.cz/en/index}{\alert{Warden}}
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Architecture [2]}
    \begin{figure}
        \includegraphics[width=9cm]{../../img/mentat/mentat-architecture}
    \end{figure}
\end{frame}


%-------------------------------------------------------------------------------


\section{Latest news}

\begin{frame}
    \frametitle{Latest news}
    \begin{itemize}
        \item Released version \href{https://homeproj.cesnet.cz/versions/81}{\alert{2.1.x}} (Thu Sep 27 2018)
        \item Migrated completely to \href{https://www.python.org/}{\alert{Python3}}
        \item Migrated database to \href{https://www.postgresql.org/}{\alert{PostgreSQL}}
        \item Automated build system \href{https://alchemist.cesnet.cz/}{\alert{Alchemist}}
        \item Autogenerated \href{https://alchemist.cesnet.cz/mentat/doc/production/html/manual.html}{\alert{documentation}}
        \begin{itemize}
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/migration.html}{\alert{migration}} from 0.4.20
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/upgrading.html}{\alert{upgrading}} from 2.0.x
        \end{itemize}
        \item Public Git code \href{https://alchemist.cesnet.cz/mentat/repo.git}{\alert{repository}} and \href{https://homeproj.cesnet.cz/projects/mentat}{\alert{issue tracker}}
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Alchemist build system}
    \href{https://alchemist.cesnet.cz/}{\texttt{https://alchemist.cesnet.cz/}}
    \begin{itemize}
        \item \alert{Automated build system for Mentat and related libraries}
        \item Contents:
        \begin{itemize}
            \item General information
            \item Build environment settings
            \item Testing, linting, benchmarking
            \item Autogenerated documentation
            \item Git repositories
            \item Debian packages
            \item Python wheels
        \end{itemize}
        \item Possible improvements:
        \begin{itemize}
            \item Installation tests, functional tests
            \item Documentation history
            \item Automated changelogs, repository stats
        \end{itemize}
    \end{itemize}
\end{frame}


%-------------------------------------------------------------------------------


\section{Current state}

\begin{frame}
    \frametitle{Libraries}
    \begin{itemize}
        \item Utils: \href{https://pypi.org/project/geoip2/}{\texttt{geoip2}}, \href{https://pypi.org/project/ply/}{\texttt{ply}}, \href{https://pypi.org/project/geoip2/}{\texttt{rrdtool}}, \href{https://pypi.org/project/psycopg2/}{\texttt{psycopg2}}
        \item Web: \href{https://pypi.org/project/Flask/}{\texttt{Flask}}, \href{https://pypi.org/project/Jinja2/}{\texttt{Jinja2}}, \href{https://pypi.org/project/Babel/}{\texttt{Babel}}, \href{https://pypi.org/project/WTForms/}{\texttt{WTForms}}, \href{https://pypi.org/project/SQLAlchemy/}{\texttt{SQLAlchemy}}
        \item \href{https://pypi.org/project/idea-format/}{\alert{idea-format}}: Library for working with IDEA messages
        \item \href{https://pypi.org/project/pynspect/}{\alert{pynspect}}: Data filtering library
        \item \href{https://pypi.org/project/pyzenkit/}{\alert{pyzenkit}}: Application development framework
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{System modules}
    \begin{itemize}
        \item Real-time event processing modules
        \begin{itemize}
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/bin_mentat-inspector.html}{\alert{mentat-inspector}} (classification and validation)
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/bin_mentat-enricher.html}{\alert{mentat-enricher}} (whois, geoip)
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/bin_mentat-storage.html}{\alert{mentat-storage}}
        \end{itemize}
        \item Event post processing modules (via database)
        \begin{itemize}
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/bin_mentat-reporter.html}{\alert{mentat-reporter}}
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/bin_mentat-statistician.html}{\alert{mentat-statistician}}
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/bin_mentat-informant.html}{\alert{mentat-informant}}
            \item (management scripts)
        \end{itemize}
        \item Control modules and user interfaces
        \begin{itemize}
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/bin_mentat-controller.html}{\alert{mentat-controller}}
            \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/_doclib/hawat.html}{\alert{Hawat}}
        \end{itemize}
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Hawat: Web interface}
    \begin{itemize}
        \item Implemented using \href{http://flask.pocoo.org/docs/1.0/}{\alert{Flask}}, \href{http://jinja.pocoo.org/docs/2.10/}{\alert{Jinja2}}, \href{http://babel.pocoo.org/en/latest/}{\alert{Babel}}, \href{http://docs.sqlalchemy.org/en/latest/}{\alert{SQLAlchemy}} and Mentat frameworks
        \item Modularization using Flask \href{http://flask.pocoo.org/docs/1.0/blueprints/}{\alert{blueprints}}
        \item Customized Flask \href{http://flask.pocoo.org/docs/1.0/patterns/subclassing/}{\alert{classes}} for deeper integration
        \begin{itemize}
            \item \href{http://flask.pocoo.org/docs/1.0/views/}{\alert{View classes}} for common tasks (item management, searching, ...)
            \item Application menu, item context menus, ...
        \end{itemize}
        \item \href{http://flask.pocoo.org/docs/1.0/}{\alert{Read Flask`s documentation!}}
    \end{itemize}
\end{frame}


%-------------------------------------------------------------------------------


\section{Resources}

\begin{frame}
    \frametitle{Essential resources}
    \begin{itemize}
        \item \href{https://homeproj.cesnet.cz/projects/mentat}{Homeproj: Project issue tracker}
        \item \href{https://homeproj.cesnet.cz/git/mentat-ng.git/}{Primary code repository}
        \item \href{https://alchemist.cesnet.cz/mentat/doc/production/html/manual.html}{Official documentation}
        \item \href{https://alchemist.cesnet.cz}{Alchemist: automated build system}
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Additional resources}
    \begin{itemize}
        \item \href{https://mentat.cesnet.cz/en/index}{Project Mentat: official website}
        \item \href{https://warden.cesnet.cz/en/index}{Project Warden: official website}
        \item \href{https://idea.cesnet.cz/en/index}{IDEA: official website}
        \item \href{https://www.postgresql.org/}{PostgreSQL: official website}
        \item \href{http://www.sphinx-doc.org/en/stable/}{Sphinx: official website}
    \end{itemize}
\end{frame}


%-------------------------------------------------------------------------------


\section*{Conclusion}
{
\setbeamertemplate{logo}{}
\begin{frame}
    \begin{center}
        \large Thank you for your attention

        \vspace{1cm}
        Jan Mach

        \href{mailto:Jan.Mach@cesnet.cz}{\texttt{Jan.Mach@cesnet.cz}} \\
        \begin{figure}
            \includegraphics[width=8cm]{../../img/logo/cesnet_RGB_lrprotect}
        \end{figure}
    \end{center}
\end{frame}
}

\end{document}

